'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.insert = insert;

var _locater = require('locater');

var _locater2 = _interopRequireDefault(_locater);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var lineBreak = '\n';

function insert(string, target, options) {

  function getModifier(nextChar, prevChar) {
    if (!options.asNewLine) {
      return string;
    }

    if (nextChar !== lineBreak) {
      string = string + '\n';
    }
    if (prevChar !== lineBreak) {
      string = '\n' + string;
    }

    return string;
  }

  function getModifiedTarget(targetIndex) {
    return target.slice(0, targetIndex) + getModifier(target[targetIndex], target[targetIndex - 1]) + target.slice(targetIndex);
  }

  if (options.after) {
    if (options.after.line) {
      var newLinePos = _locater2.default.find('\n', target, { getGlobalIndices: true });
      var targetNewLinePos = _lodash2.default.find(newLinePos, { line: options.after.line });
      var targetIndex = targetNewLinePos.globalIndex;

      return getModifiedTarget(targetIndex);
    }

    if (options.after.regex) {
      var matches = _locater2.default.find(options.after.regex, target, {
        getGlobalIndices: true,
        getMatches: true
      });
      var targetMatchPos = undefined,
          targetIndex = undefined;

      if (options.after.occurrence) {
        targetMatchPos = matches[options.after.occurrence - 1];
      } else {
        targetMatchPos = matches[0];
      }

      if (targetMatchPos.match.slice(-1) === lineBreak) {
        targetIndex = targetMatchPos.globalIndex + targetMatchPos.match.length - 1;
      } else {
        targetIndex = targetMatchPos.globalIndex + targetMatchPos.match.length;
      }

      return getModifiedTarget(targetIndex);
    }
  }

  if (options.before) {
    if (options.before.line) {
      var newLinePos = _locater2.default.find('\n', target, { getGlobalIndices: true });
      var targetNewLinePos = _lodash2.default.find(newLinePos, { line: options.before.line - 1 });
      var targetIndex = undefined;

      if (targetNewLinePos) {
        targetIndex = targetNewLinePos.globalIndex + 1;
      } else {
        targetIndex = 0;
      }

      return getModifiedTarget(targetIndex);
    }
  }
}